## hashrat 1.19

=== Makefile ===
CC = gcc
CFLAGS = -g -O2
LIBS = libUseful-5/libUseful.a -lssl -lcrypto  
INSTALL=/usr/bin/install -c
prefix=/usr
bindir=$(prefix)${exec_prefix}/bin
FLAGS=$(LDFLAGS) $(CPPFLAGS) $(CFLAGS) -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE_URL=\"\" -DHAVE_STDIO_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_STRINGS_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_UNISTD_H=1 -DSTDC_HEADERS=1 -DHAVE_LIBCRYPTO=1 -DHAVE_LIBSSL=1
OBJ=common.o encodings.o command-line-args.o ssh.o http.o fingerprint.o include-exclude.o files.o filesigning.o xattr.o check-hash.o find.o otp.o memcached.o frontend.o cgi.o xdialog.o output.o
EXE=hashrat

all: hashrat

hashrat: $(OBJ) main.c libUseful-5/libUseful.a
	$(CC) $(FLAGS) -o$(EXE) $(OBJ) main.c $(LIBS) 

libUseful-5/libUseful.a:
	@cd libUseful-5; $(MAKE)

common.o: common.h common.c
	$(CC) $(FLAGS) -c common.c

encodings.o: encodings.h encodings.c
	$(CC) $(FLAGS) -c encodings.c

fingerprint.o: fingerprint.h fingerprint.c
	$(CC) $(FLAGS) -c fingerprint.c

include-exclude.o: include-exclude.h include-exclude.c
	$(CC) $(FLAGS) -c include-exclude.c

files.o: files.h files.c
	$(CC) $(FLAGS) -c files.c

filesigning.o: filesigning.h filesigning.c
	$(CC) $(FLAGS) -c filesigning.c

find.o: find.h find.c
	$(CC) $(FLAGS) -c find.c

check-hash.o: check-hash.h check-hash.c
	$(CC) $(FLAGS) -c check-hash.c

xattr.o: xattr.h xattr.c
	$(CC) $(FLAGS) -c xattr.c

ssh.o: ssh.h ssh.c
	$(CC) $(FLAGS) -c ssh.c

http.o: http.h http.c
	$(CC) $(FLAGS) -c http.c

otp.o: otp.h otp.c
	$(CC) $(FLAGS) -c otp.c

frontend.o: frontend.h frontend.c
	$(CC) $(FLAGS) -c frontend.c

output.o: output.h output.c
	$(CC) $(FLAGS) -c output.c

cgi.o: cgi.h cgi.c
	$(CC) $(FLAGS) -c cgi.c

xdialog.o: xdialog.h xdialog.c
	$(CC) $(FLAGS) -c xdialog.c

memcached.o: memcached.h memcached.c
	$(CC) $(FLAGS) -c memcached.c

command-line-args.o: command-line-args.h command-line-args.c
	$(CC) $(FLAGS) -c command-line-args.c

check: hashrat
	@./check.sh

clean:
	-rm -f *.o */*.o */*.a */*.so *.orig $(EXE)
	-rm -f config.log config.status */config.log */config.status
	-rm -fr autom4te.cache */autom4te.cache

distclean:
	-rm -f *.o */*.o */*.a */*.so $(EXE)
	-rm -f config.log config.status */config.log */config.status Makefile */Makefile
	-rm -fr autom4te.cache */autom4te.cache


install: hashrat
	-mkdir -p $(DESTDIR)$(prefix)/bin
	cp -f $(EXE) $(DESTDIR)$(prefix)/bin
	-mkdir -p $(DESTDIR)$(prefix)/share/man/man1
	cp -f hashrat.1 $(DESTDIR)$(prefix)/share/man/man1

test:
	echo "no tests"

=== libUseful-5/Makefile ===
CC = gcc
VERSION = 5.6
CFLAGS = -g -O2 
LDFLAGS=
LIBS = -lssl -lcrypto -lc -lc -lc -lc 
FLAGS=$(LDFLAGS) $(CPPFLAGS) $(CFLAGS) -fPIC -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE_URL=\"\" -DSTDC_HEADERS=1 -DHAVE_LIBC=1 -DHAVE_GET_CURR_DIR=1 -DHAVE_PTSNAME_R=1 -DHAVE_CLEARENV=1 -DHAVE_SETRESUID=1 -DHAVE_INITGROUPS=1 -DHAVE_POLL=1 -DHAVE_MLOCK=1 -DHAVE_MLOCKALL=1 -DHAVE_MUNLOCKALL=1 -DHAVE_MADVISE=1 -DHAVE_MKOSTEMP=1 -DHAVE_MOUNT=1 -DHAVE_UMOUNT=1 -DHAVE_UMOUNT2=1 -DHAVE_GETENTROPY=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_MEMORY_H=1 -DHAVE_STRINGS_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_UNISTD_H=1 -DHAVE_SENDFILE=1 -DUSE_INET6=1 -DHAVE_LIBC=1 -DHAVE_XATTR=1 -DHAVE_LIBC=1 -DHAVE_UNSHARE=1 -DHAVE_LIBC=1 -DHAVE_SETNS=1 -DHAVE_LIBCRYPTO=1 -DHAVE_LIBSSL=1 -DHAVE_EVP_MD_CTX_NEW=1 -DHAVE_EVP_MD_CTX_FREE=1 -DHAVE_EVP_BF_CBC=1 -DHAVE_EVP_RC2_CBC=1 -DHAVE_EVP_RC4=1 -DHAVE_EVP_DES_CBC=1 -DHAVE_EVP_DESX_CBC=1 -DHAVE_EVP_CAST5_CBC=1 -DHAVE_EVP_AES_128_CBC=1 -DHAVE_EVP_AES_256_CBC=1 -DHAVE_X509_CHECK_HOST=1 -DHAVE_DECL_OPENSSL_ADD_ALL_ALGORITHMS=1 -DHAVE_OPENSSL_ADD_ALL_ALGORITHMS=1 -DHAVE_DECL_SSL_SET_TLSEXT_HOST_NAME=1 -DHAVE_SSL_SET_TLSEXT_HOST_NAME=1 -DVERSION=\"$(VERSION)\"
prefix=/usr
OBJ=StrLenCache.o String.o Array.o List.o IPAddress.o Socket.o Server.o UnixSocket.o Stream.o StreamAuth.o Errors.o Unicode.o TerminalKeys.o Terminal.o TerminalWidget.o TerminalMenu.o TerminalChoice.o TerminalBar.o TerminalTheme.o FileSystem.o GeneralFunctions.o DataProcessing.o Pty.o Log.o HttpUtil.o HttpChunkedTransfer.o Http.o Gemini.o Smtp.o Inet.o Expect.o base32.o base64.o  crc32.o md5c.o sha1.o sha2.o whirlpool.o jh_ref.o HashCRC32.o HashMD5.o HashSHA.o HashJH.o HashWhirlpool.o HashOpenSSL.o Hash.o HMAC.o Ssh.o Compression.o OAuth.o LibSettings.o Vars.o Time.o Markup.o SpawnPrograms.o Tokenizer.o StringList.o PatternMatch.o URL.o DataParser.o ConnectionChain.o OpenSSL.o Process.o Encodings.o RawData.o SecureMem.o CommandLineParser.o SysInfo.o Entropy.o Users.o UnitsOfMeasure.o HttpServer.o WebSocket.o ContentType.o PasswordFile.o OTP.o


all: $(OBJ)
	$(CC) $(FLAGS) -shared -o libUseful-$(VERSION).so $(OBJ) $(LIBS) $(LDFLAGS)
	ar rcs libUseful-$(VERSION).a $(OBJ)
	-ln -s libUseful-$(VERSION).so libUseful-5.so &>/dev/null
	-ln -s libUseful-$(VERSION).a libUseful-5.a &>/dev/null
	-ln -s libUseful-$(VERSION).so libUseful.so &>/dev/null
	-ln -s libUseful-$(VERSION).a libUseful.a &>/dev/null


StrLenCache.o: StrLenCache.h StrLenCache.c
	$(CC) $(FLAGS) -c StrLenCache.c

String.o: String.h String.c
	$(CC) $(FLAGS) -c String.c

Array.o: Array.h Array.c
	$(CC) $(FLAGS) -c Array.c

List.o: List.h List.c
	$(CC) $(FLAGS) -c List.c

IPAddress.o: IPAddress.h IPAddress.c
	$(CC) $(FLAGS) -c IPAddress.c

Socket.o: Socket.h Socket.c
	$(CC) $(FLAGS) -c Socket.c

Server.o: Server.h Server.c
	$(CC) $(FLAGS) -c Server.c

Pty.o: Pty.h Pty.c
	$(CC) $(FLAGS) -c Pty.c

HttpChunkedTransfer.o: HttpChunkedTransfer.h HttpChunkedTransfer.c
	$(CC) $(FLAGS) -c HttpChunkedTransfer.c

Http.o: Http.h Http.c
	$(CC) $(FLAGS) -c Http.c

HttpUtil.o: HttpUtil.h HttpUtil.c
	$(CC) $(FLAGS) -c HttpUtil.c

HttpServer.o: HttpServer.h HttpServer.c
	$(CC) $(FLAGS) -c HttpServer.c

Gemini.o: Gemini.h Gemini.c
	$(CC) $(FLAGS) -c Gemini.c

Smtp.o: Smtp.h Smtp.c
	$(CC) $(FLAGS) -c Smtp.c

Stream.o: Stream.h Stream.c
	$(CC) $(FLAGS) -c Stream.c

StreamAuth.o: StreamAuth.h StreamAuth.c
	$(CC) $(FLAGS) -c StreamAuth.c

Unicode.o: Unicode.c Unicode.h
	$(CC) $(FLAGS) -c Unicode.c

TerminalKeys.o: TerminalKeys.h TerminalKeys.c
	$(CC) $(FLAGS) -c TerminalKeys.c

Terminal.o: Terminal.h Terminal.c
	$(CC) $(FLAGS) -c Terminal.c

TerminalWidget.o: TerminalWidget.h TerminalWidget.c
	$(CC) $(FLAGS) -c TerminalWidget.c

TerminalMenu.o: TerminalMenu.h TerminalMenu.c
	$(CC) $(FLAGS) -c TerminalMenu.c

TerminalChoice.o: TerminalChoice.h TerminalChoice.c
	$(CC) $(FLAGS) -c TerminalChoice.c

TerminalBar.o: TerminalBar.h TerminalBar.c
	$(CC) $(FLAGS) -c TerminalBar.c

TerminalTheme.o: TerminalTheme.h TerminalTheme.c
	$(CC) $(FLAGS) -c TerminalTheme.c

Errors.o: Errors.h Errors.c
	$(CC) $(FLAGS) -c Errors.c

Log.o: Log.h Log.c
	$(CC) $(FLAGS) -c Log.c

UnixSocket.o: UnixSocket.h UnixSocket.c
	$(CC) $(FLAGS) -c UnixSocket.c

PatternMatch.o: PatternMatch.h PatternMatch.c
	$(CC) $(FLAGS) -c PatternMatch.c

FileSystem.o: FileSystem.h FileSystem.c
	$(CC) $(FLAGS) -c FileSystem.c

Time.o: Time.h Time.c
	$(CC) $(FLAGS) -c Time.c

Tokenizer.o: Tokenizer.h Tokenizer.c
	$(CC) $(FLAGS) -c Tokenizer.c

StringList.o: StringList.h StringList.c
	$(CC) $(FLAGS) -c StringList.c

Markup.o: Markup.h Markup.c
	$(CC) $(FLAGS) -c Markup.c

URL.o: URL.h URL.c
	$(CC) $(FLAGS) -c URL.c

DataParser.o: DataParser.h DataParser.c
	$(CC) $(FLAGS) -c DataParser.c

Inet.o: Inet.h Inet.c
	$(CC) $(FLAGS) -c Inet.c

Expect.o: Expect.h Expect.c
	$(CC) $(FLAGS) -c Expect.c

SecureMem.o: SecureMem.h SecureMem.c
	$(CC) $(FLAGS) -c SecureMem.c

GeneralFunctions.o: GeneralFunctions.h GeneralFunctions.c
	$(CC) $(FLAGS) -c GeneralFunctions.c

DataProcessing.o: DataProcessing.h DataProcessing.c
	$(CC) $(FLAGS) -c DataProcessing.c

HashCRC32.o: HashCRC32.h HashCRC32.c
	$(CC) $(FLAGS) -c HashCRC32.c

HashMD5.o: HashMD5.h HashMD5.c
	$(CC) $(FLAGS) -c HashMD5.c

HashSHA.o: HashSHA.h HashSHA.c
	$(CC) $(FLAGS) -c HashSHA.c

HashJH.o: HashJH.h HashJH.c
	$(CC) $(FLAGS) -c HashJH.c

HashWhirlpool.o: HashWhirlpool.h HashWhirlpool.c
	$(CC) $(FLAGS) -c HashWhirlpool.c

HashOpenSSL.o: HashOpenSSL.h HashOpenSSL.c
	$(CC) $(FLAGS) -c HashOpenSSL.c

Hash.o: Hash.h Hash.c
	$(CC) $(FLAGS) -c Hash.c

HMAC.o: HMAC.h HMAC.c
	$(CC) $(FLAGS) -c HMAC.c

Ssh.o: Ssh.h Ssh.c
	$(CC) $(FLAGS) -c Ssh.c

WebSocket.o: WebSocket.h WebSocket.c
	$(CC) $(FLAGS) -c WebSocket.c

Compression.o: Compression.h Compression.c
	$(CC) $(FLAGS) -c Compression.c

ConnectionChain.o: ConnectionChain.h ConnectionChain.c
	$(CC) $(FLAGS) -c ConnectionChain.c

base32.o: base32.c base32.h
	$(CC) $(FLAGS) -c base32.c

base64.o: base64.c base64.h
	$(CC) $(FLAGS) -c base64.c

crc32.o: crc32.c crc32.h
	$(CC) $(FLAGS) -c crc32.c

md5c.o: md5c.c md5-global.h md5.h
	$(CC) $(FLAGS) -c md5c.c

sha1.o: sha1.c sha1.h
	$(CC) $(FLAGS) -c sha1.c

sha2.o: sha2.c sha2.h
	$(CC) $(FLAGS) -DSHA2_UNROLL_TRANSFORM -c sha2.c

whirlpool.o: whirlpool.c whirlpool.h
	$(CC) $(FLAGS) -c whirlpool.c

jh_ref.o: jh_ref.c jh_ref.h
	$(CC) $(FLAGS) -c jh_ref.c

OAuth.o: OAuth.c OAuth.h
	$(CC) $(FLAGS) -c OAuth.c

OpenSSL.o: OpenSSL.c OpenSSL.h
	$(CC) $(FLAGS) -c OpenSSL.c

Process.o: Process.c Process.h
	$(CC) $(FLAGS) -c Process.c

Vars.o: Vars.c Vars.h
	$(CC) $(FLAGS) -c Vars.c

SpawnPrograms.o: SpawnPrograms.c SpawnPrograms.h
	$(CC) $(FLAGS) -c SpawnPrograms.c

Encodings.o: Encodings.c Encodings.h
	$(CC) $(FLAGS) -c Encodings.c

RawData.o: RawData.c RawData.h
	$(CC) $(FLAGS) -c RawData.c

CommandLineParser.o: CommandLineParser.c CommandLineParser.h
	$(CC) $(FLAGS) -c CommandLineParser.c

SysInfo.o: SysInfo.c SysInfo.h
	$(CC) $(FLAGS) -c SysInfo.c

Entropy.o: Entropy.c Entropy.h
	$(CC) $(FLAGS) -c Entropy.c

Users.o: Users.c Users.h
	$(CC) $(FLAGS) -c Users.c

UnitsOfMeasure.o: UnitsOfMeasure.c UnitsOfMeasure.h
	$(CC) $(FLAGS) -c UnitsOfMeasure.c

ContentType.o: ContentType.c ContentType.h
	$(CC) $(FLAGS) -c ContentType.c

PasswordFile.o: PasswordFile.c PasswordFile.h
	$(CC) $(FLAGS) -c PasswordFile.c

OTP.o: OTP.c OTP.h
	$(CC) $(FLAGS) -c OTP.c


#No dependancies, must always be compiled
LibSettings.o: LibSettings.h LibSettings.c
	$(CC) $(FLAGS) -c LibSettings.c

clean:
	-rm -f *.o *.so *.a *.orig
	-rm config.log config.status 
	-rm -r autom4te.cache config.cache

install: libUseful.so
	-mkdir -p $(DESTDIR)$(prefix)/lib 
	cp -P *.so *.a $(DESTDIR)$(prefix)/lib  
	-mkdir -p $(DESTDIR)$(prefix)/include/libUseful-$(VERSION)
	cp *.h $(DESTDIR)$(prefix)/include/libUseful-$(VERSION)
	-mkdir -p $(DESTDIR)$(prefix)/include/libUseful-5
	cp *.h $(DESTDIR)$(prefix)/include/libUseful-5
	-mkdir -p $(DESTDIR)$(prefix)/etc
	cp *.conf $(DESTDIR)$(prefix)/etc


test: libUseful.so
	-echo "No tests written yet"

=== libUseful-5/examples/Makefile ===
LIBS=../libUseful.a -lssl -lcrypto -lz #-lcap

all:
	gcc -oJSON.exe JSON.c $(LIBS)
	gcc -oCMON.exe CMON.c $(LIBS)
	gcc -oYAML.exe YAML.c $(LIBS)
	gcc -oHash.exe Hash.c $(LIBS)
	gcc -oHMAC.exe HMAC.c $(LIBS)
	gcc -oTerminal.exe Terminal.c $(LIBS)
	gcc -oTermBar.exe TermBar.c $(LIBS)
	gcc -oVars.exe Vars.c $(LIBS)
	gcc -oParseRSS.exe ParseRSS.c $(LIBS)
	gcc -oFileCopy.exe FileCopy.c $(LIBS)
	gcc -oTokenize.exe Tokenize.c $(LIBS)
	gcc -oSpawnContainer.exe SpawnContainer.c $(LIBS)
	gcc -oMaps.exe Maps.c $(LIBS)
	gcc -oTTYTest.exe TTYTest.c $(LIBS)
	gcc -oErrors.exe Errors.c $(LIBS)
	gcc -ossh-tunnel.exe ssh-tunnel.c $(LIBS)
	gcc -oConfig.exe Config.c $(LIBS)
	gcc -oStrLen.exe StrLen.c $(LIBS)
	gcc -oSSLClient.exe SSLClient.c $(LIBS)
	gcc -oSysInfo.exe SysInfo.c $(LIBS)
	gcc -oWebsocket.exe Websocket.c $(LIBS)
	gcc -oHttpServer.exe HttpServer.c $(LIBS)
	gcc -oPasswordFile.exe PasswordFile.c $(LIBS)
	gcc -obase32.exe base32.c $(LIBS)

=== debian/changelog ===
hashrat (1.19-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Update standards version to 4.6.0, no changes needed.

  [ Arnaud Rebillout ]
  * Fix watch file
  * New upstream version 1.19
  * Update copyright
  * Rebuild patches so that it applies
  * Fix build without OpenSSL
  * Re-enable tests

 -- Arnaud Rebillout <arnaudr@kali.org>  Mon, 27 May 2024 16:18:54 +0700

=== debian/control ===
Source: hashrat
Section: utils
Priority: optional
Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
Uploaders: Giovani Augusto Ferreira <giovani@debian.org>
Rules-Requires-Root: binary-targets
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.6.0
Homepage: https://github.com/ColumPaget/Hashrat/
Vcs-Git: https://salsa.debian.org/pkg-security-team/hashrat.git
Vcs-Browser: https://salsa.debian.org/pkg-security-team/hashrat

Package: hashrat
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: hashing tool supporting several hashes and recursivity
 Hashrat is a hash-generation utility that supports the md5, sha1, sha256,
 sha512, whirlpool, jh-244, jh256, jh-384 and jh-512 hash functions, and
 also the HMAC versions of those functions. It can output in 'traditional'
 format (same as md5sum and shasum and the like), or it's own format.
 .
 Hashes can be output in octal, decimal, hexadecimal, uppercase hexadecimal
 or base64.
 .
 Hashrat also supports directory recursion, hashing entire devices,
 generating a hash for an entire directory, operations in remote machines
 and several other features. It has a 'CGI' mode that can be used as a
 web-page to lookup hashes.
 .
 This tool is useful in forensics investigations and network security.

## hashrat 1.20

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,10 @@
 CC = gcc
-CFLAGS = -g -O2
-LIBS = libUseful-5/libUseful.a -lssl -lcrypto  
+CFLAGS = -g -O2 -O2 -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3 -fstack-protector-strong
+LIBS = libUseful-5/libUseful.a -lssl -lcrypto -lz  
 INSTALL=/usr/bin/install -c
-prefix=/usr
+prefix=/usr/local
 bindir=$(prefix)${exec_prefix}/bin
-FLAGS=$(LDFLAGS) $(CPPFLAGS) $(CFLAGS) -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE_URL=\"\" -DHAVE_STDIO_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_STRINGS_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_UNISTD_H=1 -DSTDC_HEADERS=1 -DHAVE_LIBCRYPTO=1 -DHAVE_LIBSSL=1
+FLAGS=$(LDFLAGS) $(CPPFLAGS) $(CFLAGS) -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE_URL=\"\" -DHAVE_STDIO_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_STRINGS_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_UNISTD_H=1 -DSTDC_HEADERS=1 -DHAVE_LIBZ=1 -DHAVE_LIBCRYPTO=1 -DHAVE_LIBSSL=1
 OBJ=common.o encodings.o command-line-args.o ssh.o http.o fingerprint.o include-exclude.o files.o filesigning.o xattr.o check-hash.o find.o otp.o memcached.o frontend.o cgi.o xdialog.o output.o
 EXE=hashrat
 
@@ -74,7 +74,7 @@
 	@./check.sh
 
 clean:
-	-rm -f *.o */*.o */*.a */*.so *.orig $(EXE)
+	-rm -f *.o */*.o */*.a */*.so *.orig *.out $(EXE)
 	-rm -f config.log config.status */config.log */config.status
 	-rm -fr autom4te.cache */autom4te.cache

=== libUseful-5/Makefile ===
--- 
+++ 
@@ -1,20 +1,26 @@
 CC = gcc
-VERSION = 5.6
-CFLAGS = -g -O2 
+VERSION = 5.14
+MAJOR=5
+LIBFILE=libUseful.so.$(VERSION)
+SONAME=libUseful.so.$(MAJOR)
+CFLAGS = -g -O2 -O2 -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3 -fstack-protector-strong  -Wl,-soname,${SONAME}
 LDFLAGS=
-LIBS = -lssl -lcrypto -lc -lc -lc -lc 
-FLAGS=$(LDFLAGS) $(CPPFLAGS) $(CFLAGS) -fPIC -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE_URL=\"\" -DSTDC_HEADERS=1 -DHAVE_LIBC=1 -DHAVE_GET_CURR_DIR=1 -DHAVE_PTSNAME_R=1 -DHAVE_CLEARENV=1 -DHAVE_SETRESUID=1 -DHAVE_INITGROUPS=1 -DHAVE_POLL=1 -DHAVE_MLOCK=1 -DHAVE_MLOCKALL=1 -DHAVE_MUNLOCKALL=1 -DHAVE_MADVISE=1 -DHAVE_MKOSTEMP=1 -DHAVE_MOUNT=1 -DHAVE_UMOUNT=1 -DHAVE_UMOUNT2=1 -DHAVE_GETENTROPY=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_MEMORY_H=1 -DHAVE_STRINGS_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_UNISTD_H=1 -DHAVE_SENDFILE=1 -DUSE_INET6=1 -DHAVE_LIBC=1 -DHAVE_XATTR=1 -DHAVE_LIBC=1 -DHAVE_UNSHARE=1 -DHAVE_LIBC=1 -DHAVE_SETNS=1 -DHAVE_LIBCRYPTO=1 -DHAVE_LIBSSL=1 -DHAVE_EVP_MD_CTX_NEW=1 -DHAVE_EVP_MD_CTX_FREE=1 -DHAVE_EVP_BF_CBC=1 -DHAVE_EVP_RC2_CBC=1 -DHAVE_EVP_RC4=1 -DHAVE_EVP_DES_CBC=1 -DHAVE_EVP_DESX_CBC=1 -DHAVE_EVP_CAST5_CBC=1 -DHAVE_EVP_AES_128_CBC=1 -DHAVE_EVP_AES_256_CBC=1 -DHAVE_X509_CHECK_HOST=1 -DHAVE_DECL_OPENSSL_ADD_ALL_ALGORITHMS=1 -DHAVE_OPENSSL_ADD_ALL_ALGORITHMS=1 -DHAVE_DECL_SSL_SET_TLSEXT_HOST_NAME=1 -DHAVE_SSL_SET_TLSEXT_HOST_NAME=1 -DVERSION=\"$(VERSION)\"
-prefix=/usr
-OBJ=StrLenCache.o String.o Array.o List.o IPAddress.o Socket.o Server.o UnixSocket.o Stream.o StreamAuth.o Errors.o Unicode.o TerminalKeys.o Terminal.o TerminalWidget.o TerminalMenu.o TerminalChoice.o TerminalBar.o TerminalTheme.o FileSystem.o GeneralFunctions.o DataProcessing.o Pty.o Log.o HttpUtil.o HttpChunkedTransfer.o Http.o Gemini.o Smtp.o Inet.o Expect.o base32.o base64.o  crc32.o md5c.o sha1.o sha2.o whirlpool.o jh_ref.o HashCRC32.o HashMD5.o HashSHA.o HashJH.o HashWhirlpool.o HashOpenSSL.o Hash.o HMAC.o Ssh.o Compression.o OAuth.o LibSettings.o Vars.o Time.o Markup.o SpawnPrograms.o Tokenizer.o StringList.o PatternMatch.o URL.o DataParser.o ConnectionChain.o OpenSSL.o Process.o Encodings.o RawData.o SecureMem.o CommandLineParser.o SysInfo.o Entropy.o Users.o UnitsOfMeasure.o HttpServer.o WebSocket.o ContentType.o PasswordFile.o OTP.o
+LIBS = -lz -lssl -lcrypto -lc -lc -lc -lc 
+prefix=/usr/local
+sysconfdir=${prefix}/etc
+FLAGS=$(LDFLAGS) $(CPPFLAGS) $(CFLAGS) -fPIC -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE_URL=\"\" -DHAVE_LIBC=1 -DHAVE_GET_CURR_DIR=1 -DHAVE_PTSNAME_R=1 -DHAVE_CLEARENV=1 -DHAVE_SETRESUID=1 -DHAVE_INITGROUPS=1 -DHAVE_POLL=1 -DHAVE_MLOCK=1 -DHAVE_MLOCKALL=1 -DHAVE_MUNLOCKALL=1 -DHAVE_MADVISE=1 -DHAVE_MKOSTEMP=1 -DHAVE_MOUNT=1 -DHAVE_UMOUNT=1 -DHAVE_UMOUNT2=1 -DHAVE_GETENTROPY=1 -DHAVE_STDIO_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_STRINGS_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_UNISTD_H=1 -DSTDC_HEADERS=1 -DHAVE_SENDFILE=1 -DUSE_INET6=1 -DHAVE_LIBC=1 -DHAVE_XATTR=1 -DHAVE_LIBC=1 -DHAVE_UNSHARE=1 -DHAVE_LIBC=1 -DHAVE_SETNS=1 -DHAVE_LIBCRYPTO=1 -DHAVE_LIBSSL=1 -DHAVE_EVP_MD_CTX_NEW=1 -DHAVE_EVP_MD_CTX_FREE=1 -DHAVE_EVP_BF_CBC=1 -DHAVE_EVP_RC2_CBC=1 -DHAVE_EVP_RC4=1 -DHAVE_EVP_DES_CBC=1 -DHAVE_EVP_DESX_CBC=1 -DHAVE_EVP_CAST5_CBC=1 -DHAVE_EVP_AES_128_CBC=1 -DHAVE_EVP_AES_256_CBC=1 -DHAVE_X509_CHECK_HOST=1 -DHAVE_DECL_OPENSSL_ADD_ALL_ALGORITHMS=1 -DHAVE_OPENSSL_ADD_ALL_ALGORITHMS=1 -DHAVE_DECL_SSL_SET_TLSEXT_HOST_NAME=1 -DHAVE_SSL_SET_TLSEXT_HOST_NAME=1 -DHAVE_LIBZ=1 -DVERSION=\"$(VERSION)\" -DSYSCONFDIR=\"$(sysconfdir)\"
+OBJ=StrLenCache.o String.o Array.o List.o IPAddress.o Socket.o Server.o UnixSocket.o Stream.o StreamAuth.o Errors.o Unicode.o TerminalKeys.o Terminal.o TerminalWidget.o TerminalMenu.o TerminalChoice.o TerminalBar.o TerminalProgress.o TerminalTheme.o FileSystem.o GeneralFunctions.o DataProcessing.o Pty.o Log.o HttpUtil.o HttpChunkedTransfer.o Http.o Gemini.o Smtp.o Inet.o Expect.o base32.o base64.o  crc32.o md5c.o sha1.o sha2.o whirlpool.o jh_ref.o HashCRC32.o HashMD5.o HashSHA.o HashJH.o HashWhirlpool.o HashOpenSSL.o Hash.o HMAC.o Ssh.o Compression.o OAuth.o LibSettings.o Vars.o Time.o Markup.o SpawnPrograms.o Tokenizer.o StringList.o PatternMatch.o URL.o DataParser.o ConnectionChain.o OpenSSL.o Process.o Encodings.o RawData.o SecureMem.o CommandLineParser.o SysInfo.o Entropy.o Users.o UnitsOfMeasure.o HttpServer.o WebSocket.o ContentType.o PasswordFile.o OTP.o
 
 
 all: $(OBJ)
-	$(CC) $(FLAGS) -shared -o libUseful-$(VERSION).so $(OBJ) $(LIBS) $(LDFLAGS)
+	$(CC) $(FLAGS) -shared -o $(LIBFILE) $(OBJ) $(LIBS) $(LDFLAGS)
+	-ln -s -r -f $(LIBFILE) libUseful-$(VERSION).so
+	-ln -s -r -f $(LIBFILE) libUseful-$(MAJOR).so
+	-ln -s -r -f $(LIBFILE) $(SONAME)
+	-ln -s -r -f $(LIBFILE) libUseful.so
 	ar rcs libUseful-$(VERSION).a $(OBJ)
-	-ln -s libUseful-$(VERSION).so libUseful-5.so &>/dev/null
-	-ln -s libUseful-$(VERSION).a libUseful-5.a &>/dev/null
-	-ln -s libUseful-$(VERSION).so libUseful.so &>/dev/null
-	-ln -s libUseful-$(VERSION).a libUseful.a &>/dev/null
+	-ln -s -r -f libUseful-$(VERSION).a libUseful-$(MAJOR).a
+	-ln -s -r -f libUseful-$(VERSION).a libUseful.a
 
 
 StrLenCache.o: StrLenCache.h StrLenCache.c
@@ -85,6 +91,9 @@
 
 TerminalBar.o: TerminalBar.h TerminalBar.c
 	$(CC) $(FLAGS) -c TerminalBar.c
+
+TerminalProgress.o: TerminalProgress.h TerminalProgress.c
+	$(CC) $(FLAGS) -c TerminalProgress.c
 
 TerminalTheme.o: TerminalTheme.h TerminalTheme.c
 	$(CC) $(FLAGS) -c TerminalTheme.c
@@ -248,17 +257,17 @@
 	$(CC) $(FLAGS) -c LibSettings.c
 
 clean:
-	-rm -f *.o *.so *.a *.orig
+	-rm -f *.o *.so *.so.* *.a *.orig
 	-rm config.log config.status 
 	-rm -r autom4te.cache config.cache
+	-$(MAKE) clean -C examples
 
 install: libUseful.so
 	-mkdir -p $(DESTDIR)$(prefix)/lib 
-	cp -P *.so *.a $(DESTDIR)$(prefix)/lib  
+	cp -P *.so *.so.* *.a $(DESTDIR)$(prefix)/lib  
 	-mkdir -p $(DESTDIR)$(prefix)/include/libUseful-$(VERSION)
 	cp *.h $(DESTDIR)$(prefix)/include/libUseful-$(VERSION)
-	-mkdir -p $(DESTDIR)$(prefix)/include/libUseful-5
-	cp *.h $(DESTDIR)$(prefix)/include/libUseful-5
+	-ln -s -r -f $(DESTDIR)$(prefix)/include/libUseful-$(VERSION) $(DESTDIR)$(prefix)/include/libUseful-5
 	-mkdir -p $(DESTDIR)$(prefix)/etc
 	cp *.conf $(DESTDIR)$(prefix)/etc

=== libUseful-5/examples/Makefile ===
--- 
+++ 
@@ -8,6 +8,7 @@
 	gcc -oHMAC.exe HMAC.c $(LIBS)
 	gcc -oTerminal.exe Terminal.c $(LIBS)
 	gcc -oTermBar.exe TermBar.c $(LIBS)
+	gcc -oTermProgress.exe TermProgress.c $(LIBS)
 	gcc -oVars.exe Vars.c $(LIBS)
 	gcc -oParseRSS.exe ParseRSS.c $(LIBS)
 	gcc -oFileCopy.exe FileCopy.c $(LIBS)

=== debian/changelog ===
hashrat (1.20-1) unstable; urgency=medium

  [ Niels Thykier ]
  * Set `Rules-Requires-Root: no`, since `(fake)root` is not needed

  [ Arnaud Rebillout ]
  * New upstream version 1.20
  * Drop patches applied upstream, adjust existing patches
  * Bump Standards-Version (no change required)

 -- Arnaud Rebillout <arnaudr@kali.org>  Wed, 19 Jun 2024 08:03:03 +0700

=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Debian Security Tools <team+pkg-security@tracker.debian.org>
 Uploaders: Giovani Augusto Ferreira <giovani@debian.org>
-Rules-Requires-Root: binary-targets
+Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.6.0
+Standards-Version: 4.7.0
 Homepage: https://github.com/ColumPaget/Hashrat/
 Vcs-Git: https://salsa.debian.org/pkg-security-team/hashrat.git
 Vcs-Browser: https://salsa.debian.org/pkg-security-team/hashrat

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- --enable-xattr

=== debian/watch ===
version=4
opts="filenamemangle=s%.*/@ANY_VERSION@%@PACKAGE@-$1.tar.gz%,searchmode=plain" \
    https://api.github.com/repos/ColumPaget/Hashrat/releases?per_page=100 \
    https://api.github.com/repos/ColumPaget/Hashrat/tarball/@ANY_VERSION@

## hashrat 1.23+ds

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,10 @@
 CC = gcc
-CFLAGS = -g -O2 -O2 -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3 -fstack-protector-strong
+CFLAGS = -g -O2
 LIBS = libUseful-5/libUseful.a -lssl -lcrypto -lz  
-INSTALL=/usr/bin/install -c
+INSTALL=/bin/install -c
 prefix=/usr/local
 bindir=$(prefix)${exec_prefix}/bin
-FLAGS=$(LDFLAGS) $(CPPFLAGS) $(CFLAGS) -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE_URL=\"\" -DHAVE_STDIO_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_STRINGS_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_UNISTD_H=1 -DSTDC_HEADERS=1 -DHAVE_LIBZ=1 -DHAVE_LIBCRYPTO=1 -DHAVE_LIBSSL=1
+FLAGS=$(LDFLAGS) $(CPPFLAGS) $(CFLAGS) -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE_URL=\"\" -DHAVE_STDIO_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_STRINGS_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_UNISTD_H=1 -DSTDC_HEADERS=1 -D_FILE_OFFSET_BITS=64 -DHAVE_LIBZ=1 -DHAVE_LIBCRYPTO=1 -DHAVE_LIBSSL=1
 OBJ=common.o encodings.o command-line-args.o ssh.o http.o fingerprint.o include-exclude.o files.o filesigning.o xattr.o check-hash.o find.o otp.o memcached.o frontend.o cgi.o xdialog.o output.o
 EXE=hashrat

=== libUseful-5/Makefile ===
--- 
+++ 
@@ -1,15 +1,16 @@
 CC = gcc
-VERSION = 5.14
+AR = ar
+VERSION = 5.30
 MAJOR=5
 LIBFILE=libUseful.so.$(VERSION)
 SONAME=libUseful.so.$(MAJOR)
-CFLAGS = -g -O2 -O2 -U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=3 -fstack-protector-strong  -Wl,-soname,${SONAME}
+CFLAGS = -g -O2  -Wl,-soname,${SONAME}
 LDFLAGS=
 LIBS = -lz -lssl -lcrypto -lc -lc -lc -lc 
 prefix=/usr/local
 sysconfdir=${prefix}/etc
-FLAGS=$(LDFLAGS) $(CPPFLAGS) $(CFLAGS) -fPIC -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE_URL=\"\" -DHAVE_LIBC=1 -DHAVE_GET_CURR_DIR=1 -DHAVE_PTSNAME_R=1 -DHAVE_CLEARENV=1 -DHAVE_SETRESUID=1 -DHAVE_INITGROUPS=1 -DHAVE_POLL=1 -DHAVE_MLOCK=1 -DHAVE_MLOCKALL=1 -DHAVE_MUNLOCKALL=1 -DHAVE_MADVISE=1 -DHAVE_MKOSTEMP=1 -DHAVE_MOUNT=1 -DHAVE_UMOUNT=1 -DHAVE_UMOUNT2=1 -DHAVE_GETENTROPY=1 -DHAVE_STDIO_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_STRINGS_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_UNISTD_H=1 -DSTDC_HEADERS=1 -DHAVE_SENDFILE=1 -DUSE_INET6=1 -DHAVE_LIBC=1 -DHAVE_XATTR=1 -DHAVE_LIBC=1 -DHAVE_UNSHARE=1 -DHAVE_LIBC=1 -DHAVE_SETNS=1 -DHAVE_LIBCRYPTO=1 -DHAVE_LIBSSL=1 -DHAVE_EVP_MD_CTX_NEW=1 -DHAVE_EVP_MD_CTX_FREE=1 -DHAVE_EVP_BF_CBC=1 -DHAVE_EVP_RC2_CBC=1 -DHAVE_EVP_RC4=1 -DHAVE_EVP_DES_CBC=1 -DHAVE_EVP_DESX_CBC=1 -DHAVE_EVP_CAST5_CBC=1 -DHAVE_EVP_AES_128_CBC=1 -DHAVE_EVP_AES_256_CBC=1 -DHAVE_X509_CHECK_HOST=1 -DHAVE_DECL_OPENSSL_ADD_ALL_ALGORITHMS=1 -DHAVE_OPENSSL_ADD_ALL_ALGORITHMS=1 -DHAVE_DECL_SSL_SET_TLSEXT_HOST_NAME=1 -DHAVE_SSL_SET_TLSEXT_HOST_NAME=1 -DHAVE_LIBZ=1 -DVERSION=\"$(VERSION)\" -DSYSCONFDIR=\"$(sysconfdir)\"
-OBJ=StrLenCache.o String.o Array.o List.o IPAddress.o Socket.o Server.o UnixSocket.o Stream.o StreamAuth.o Errors.o Unicode.o TerminalKeys.o Terminal.o TerminalWidget.o TerminalMenu.o TerminalChoice.o TerminalBar.o TerminalProgress.o TerminalTheme.o FileSystem.o GeneralFunctions.o DataProcessing.o Pty.o Log.o HttpUtil.o HttpChunkedTransfer.o Http.o Gemini.o Smtp.o Inet.o Expect.o base32.o base64.o  crc32.o md5c.o sha1.o sha2.o whirlpool.o jh_ref.o HashCRC32.o HashMD5.o HashSHA.o HashJH.o HashWhirlpool.o HashOpenSSL.o Hash.o HMAC.o Ssh.o Compression.o OAuth.o LibSettings.o Vars.o Time.o Markup.o SpawnPrograms.o Tokenizer.o StringList.o PatternMatch.o URL.o DataParser.o ConnectionChain.o OpenSSL.o Process.o Encodings.o RawData.o SecureMem.o CommandLineParser.o SysInfo.o Entropy.o Users.o UnitsOfMeasure.o HttpServer.o WebSocket.o ContentType.o PasswordFile.o OTP.o
+FLAGS=$(LDFLAGS) $(CPPFLAGS) $(CFLAGS) -fPIC -DPACKAGE_NAME=\"\" -DPACKAGE_TARNAME=\"\" -DPACKAGE_VERSION=\"\" -DPACKAGE_STRING=\"\" -DPACKAGE_BUGREPORT=\"\" -DPACKAGE_URL=\"\" -D_FILE_OFFSET_BITS=64 -DHAVE_LIBC=1 -DHAVE_GET_CURR_DIR=1 -DHAVE_PTSNAME_R=1 -DHAVE_CLEARENV=1 -DHAVE_SETRESUID=1 -DHAVE_INITGROUPS=1 -DHAVE_POLL=1 -DHAVE_MLOCK=1 -DHAVE_MLOCKALL=1 -DHAVE_MUNLOCKALL=1 -DHAVE_MADVISE=1 -DHAVE_MKOSTEMP=1 -DHAVE_MOUNT=1 -DHAVE_UMOUNT=1 -DHAVE_UMOUNT2=1 -DHAVE_GETENTROPY=1 -DHAVE_PRCTL=1 -DHAVE_STDIO_H=1 -DHAVE_STDLIB_H=1 -DHAVE_STRING_H=1 -DHAVE_INTTYPES_H=1 -DHAVE_STDINT_H=1 -DHAVE_STRINGS_H=1 -DHAVE_SYS_STAT_H=1 -DHAVE_SYS_TYPES_H=1 -DHAVE_UNISTD_H=1 -DSTDC_HEADERS=1 -DHAVE_SENDFILE=1 -DUSE_INET6=1 -DHAVE_LIBC=1 -DHAVE_XATTR=1 -DHAVE_LIBC=1 -DHAVE_UNSHARE=1 -DHAVE_LIBC=1 -DHAVE_SETNS=1 -DHAVE_LIBCRYPTO=1 -DHAVE_LIBSSL=1 -DHAVE_EVP_MD_CTX_CREATE=1 -DHAVE_EVP_MD_CTX_NEW=1 -DHAVE_EVP_MD_CTX_DESTROY=1 -DHAVE_EVP_MD_CTX_FREE=1 -DHAVE_X509_CHECK_HOST=1 -DHAVE_SSL_SET_MIN_PROTO_VERSION=1 -DHAVE_DECL_OPENSSL_ADD_ALL_ALGORITHMS=1 -DHAVE_OPENSSL_ADD_ALL_ALGORITHMS=1 -DHAVE_DECL_SSL_SET_TLSEXT_HOST_NAME=1 -DHAVE_SSL_SET_TLSEXT_HOST_NAME=1 -DHAVE_LIBZ=1 -DVERSION=\"$(VERSION)\" -DSYSCONFDIR=\"$(sysconfdir)\"
+OBJ=StrLenCache.o String.o Array.o List.o IPAddress.o Socket.o Server.o UnixSocket.o Stream.o StreamAuth.o Errors.o Unicode.o TerminalKeys.o Terminal.o TerminalWidget.o TerminalMenu.o TerminalChoice.o TerminalBar.o TerminalProgress.o TerminalTheme.o FileSystem.o GeneralFunctions.o DataProcessing.o Pty.o Log.o HttpUtil.o HttpChunkedTransfer.o Http.o Gemini.o Smtp.o Inet.o Expect.o base32.o base64.o  crc32.o md5c.o sha1.o sha2.o whirlpool.o jh_ref.o HashCRC32.o HashMD5.o HashSHA.o HashJH.o HashWhirlpool.o HashOpenSSL.o Hash.o HMAC.o Ssh.o Compression.o Encryption.o OAuth.o LibSettings.o Vars.o Time.o Markup.o SpawnPrograms.o Tokenizer.o StringList.o PatternMatch.o URL.o DataParser.o ConnectionChain.o OpenSSL.o Seccomp.o Process.o Container.o Encodings.o RawData.o SecureMem.o CommandLineParser.o SysInfo.o Entropy.o Users.o UnitsOfMeasure.o HttpServer.o WebSocket.o ContentType.o PasswordFile.o OTP.o CGI.o
 
 
 all: $(OBJ)
@@ -18,7 +19,7 @@
 	-ln -s -r -f $(LIBFILE) libUseful-$(MAJOR).so
 	-ln -s -r -f $(LIBFILE) $(SONAME)
 	-ln -s -r -f $(LIBFILE) libUseful.so
-	ar rcs libUseful-$(VERSION).a $(OBJ)
+	$(AR) rcs libUseful-$(VERSION).a $(OBJ)
 	-ln -s -r -f libUseful-$(VERSION).a libUseful-$(MAJOR).a
 	-ln -s -r -f libUseful-$(VERSION).a libUseful.a
 
@@ -179,6 +180,9 @@
 Compression.o: Compression.h Compression.c
 	$(CC) $(FLAGS) -c Compression.c
 
+Encryption.o: Encryption.h Encryption.c
+	$(CC) $(FLAGS) -c Encryption.c
+
 ConnectionChain.o: ConnectionChain.h ConnectionChain.c
 	$(CC) $(FLAGS) -c ConnectionChain.c
 
@@ -215,6 +219,12 @@
 Process.o: Process.c Process.h
 	$(CC) $(FLAGS) -c Process.c
 
+Container.o: Container.c Container.h
+	$(CC) $(FLAGS) -c Container.c
+
+Seccomp.o: Seccomp.c Seccomp.h
+	$(CC) $(FLAGS) -c Seccomp.c
+
 Vars.o: Vars.c Vars.h
 	$(CC) $(FLAGS) -c Vars.c
 
@@ -250,6 +260,10 @@
 
 OTP.o: OTP.c OTP.h
 	$(CC) $(FLAGS) -c OTP.c
+
+CGI.o: CGI.c CGI.h
+	$(CC) $(FLAGS) -c CGI.c
+
 
 
 #No dependancies, must always be compiled
@@ -257,7 +271,7 @@
 	$(CC) $(FLAGS) -c LibSettings.c
 
 clean:
-	-rm -f *.o *.so *.so.* *.a *.orig
+	-rm -f *.o *.so *.so.* *.a *.orig .*.swp *~
 	-rm config.log config.status 
 	-rm -r autom4te.cache config.cache
 	-$(MAKE) clean -C examples

=== libUseful-5/examples/Makefile ===
--- 
+++ 
@@ -8,6 +8,8 @@
 	gcc -oHMAC.exe HMAC.c $(LIBS)
 	gcc -oTerminal.exe Terminal.c $(LIBS)
 	gcc -oTermBar.exe TermBar.c $(LIBS)
+	gcc -oTermMenu.exe TermMenu.c $(LIBS)
+	gcc -oTermChoice.exe TermChoice.c $(LIBS)
 	gcc -oTermProgress.exe TermProgress.c $(LIBS)
 	gcc -oVars.exe Vars.c $(LIBS)
 	gcc -oParseRSS.exe ParseRSS.c $(LIBS)
@@ -17,7 +19,9 @@
 	gcc -oMaps.exe Maps.c $(LIBS)
 	gcc -oTTYTest.exe TTYTest.c $(LIBS)
 	gcc -oErrors.exe Errors.c $(LIBS)
+	gcc -ossh-time.exe ssh-time.c $(LIBS)
 	gcc -ossh-tunnel.exe ssh-tunnel.c $(LIBS)
+	gcc -ossh-listfiles.exe ssh-listfiles.c $(LIBS)
 	gcc -oConfig.exe Config.c $(LIBS)
 	gcc -oStrLen.exe StrLen.c $(LIBS)
 	gcc -oSSLClient.exe SSLClient.c $(LIBS)
@@ -26,3 +30,15 @@
 	gcc -oHttpServer.exe HttpServer.c $(LIBS)
 	gcc -oPasswordFile.exe PasswordFile.c $(LIBS)
 	gcc -obase32.exe base32.c $(LIBS)
+	gcc -ouudecode.exe uudecode.c $(LIBS)
+	gcc -ononewprivs.exe nonewprivs.c $(LIBS)
+	gcc -ochroot.exe chroot.c $(LIBS)
+	gcc -omovetest.exe movetest.c $(LIBS)
+	gcc -oencrypt.exe encrypt.c $(LIBS)
+	gcc -odecrypt.exe decrypt.c $(LIBS)
+	gcc -opbkdf2.exe pbkdf2.c $(LIBS)
+seccomp.exe: seccomp.c
+	gcc -oseccomp.exe seccomp.c $(LIBS)
+
+clean:
+	rm -f *.exe

=== debian/changelog ===
hashrat (1.23+ds-1) unstable; urgency=medium

  * New upstream version 1.23+ds
  * d/control:
    - Add Build-Depends: libssl-dev and zlib1g-dev
    - Add myself to Uploaders
  * d/copyright:
    - Add myself to debian/*
    - Change license name from MIT to HPND-MIT-disclaimer
    - Exclude pre-compiled libUseful.so.5 due to DS violation
    - Update to reflect upstream copyright changes
  * d/patches:
    - Add-more-flags-to-improve-GCC...patch: Set forwarded and apply DEP-3
    - Fix-libUseful-Makefile.patch: Update patch, set forwarded and apply DEP-3
    - Fix-manpage-font-formatting.patch: New patch to fix manpage formatting
    - Fix-some-spelling...patch: Refresh patch, forwarded and apply DEP-3
  * d/rules:
    - Add execute_before_dh_autoreconf to copy ar-lib
    - Enable support for zlib and ssl in dh_auto_configure
  * d/watch
    - Add repacksuffix for +ds and dversionmangle
    - Reorganize to standard format and remove filenamemangle

 -- Matheus Polkorny <mpolkorny@gmail.com>  Thu, 27 Feb 2025 00:09:07 -0300

=== debian/watch ===
version=4
opts="searchmode=plain, \
      dversionmangle=s/@DEB_EXT@//, \
      repacksuffix=+ds" \
https://api.github.com/repos/ColumPaget/Hashrat/releases?per_page=100 \
https://api.github.com/repos/ColumPaget/Hashrat/tarball/@ANY_VERSION@
